# 32/64bit spec-file
#
%define 	__spec_install_post %{nil}
%define 	name webmin
%define 	version 1.870
%define 	release %mkrel 1
%define 	prefix %{_prefix}

%define _requires_exceptions libc.so.1\\|libintl.so.3\\|libsecdb.so.1\\|libsocket.so.1\\|perl(Encode::HanConvert)\\|perl(timelocal.pl\\|perl(webmin-lib.pl

Summary: 	A web-based administration interface for Unix systems.
Summary(de):	Eine webbasierte Administrationsschnittstelle für Unix Systeme.
Name: 		%name
Version: 	%version
Release: 	%release
Provides: 	%{name}-%{version}
Requires(pre): 	/bin/sh /usr/bin/perl /bin/rm
Requires: 	/bin/sh /usr/bin/perl /bin/rm
License: 	Freeware
Group: 		System/Serviers
Source: 	http://www.webmin.com/download/%{name}-%{version}.tar.xz
Patch0:		%{name}-distrofix.patch
BuildRoot: 	%_tmppath/%name-%version-buildroot
URL:		http://www.webmin.com/
BuildArchitectures: noarch
AutoReqProv: no

%description
A web-based administration interface for Unix systems. Using Webmin you can
configure DNS, Samba, NFS, local/remote filesystems and more using your
web browser.

After installation, enter the URL http://localhost:10000/ into your
browser and login as root with your root password.

%description -l de
Eine webbasierte Administrationsschnittstelle für Uniy Systeme. Wenn Sie Webmin
nutzen können Sie DNS, Samba, NFS, lokale/entfernte Dateisysteme konfigurieren und 
noch mehr nur durch die Benutzung der Webbrowsers.

Geben Sie nach der Installation die URL http://localhost:10000/ in Ihrem Browser
ein und melden sich mit dem root-Passwort an.


%prep
%setup -q
%patch0 -p1 -b .distrofix

%build
(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
rm -f mount/freebsd-mounts*
rm -f mount/openbsd-mounts*
rm -f mount/macos-mounts*
rm -f webmin-gentoo-init
rm -rf format bsdexports hpuxexports sgiexports zones rbac
rm -rf acl/Authen-SolarisRBAC-0.1*
chmod -R og-w .

%install
mkdir -p %{buildroot}/usr/libexec/webmin
mkdir -p %{buildroot}/etc/sysconfig/daemons
mkdir -p %{buildroot}/etc/rc.d/{rc0.d,rc1.d,rc2.d,rc3.d,rc5.d,rc6.d}
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/pam.d
cp -rp * %{buildroot}/usr/libexec/webmin
cp webmin-daemon %{buildroot}/etc/sysconfig/daemons/webmin
cp webmin-init %{buildroot}/etc/init.d/webmin
cp webmin-pam %{buildroot}/etc/pam.d/webmin
ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc2.d/S99webmin
ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc3.d/S99webmin
ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc5.d/S99webmin
ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc0.d/K10webmin
ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc1.d/K10webmin
ln -s /etc/init.d/webmin %{buildroot}/etc/rc.d/rc6.d/K10webmin
echo rpm >%{buildroot}/usr/libexec/webmin/install-type

%clean
#%{rmDESTDIR}
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
/usr/libexec/webmin
%config /etc/sysconfig/daemons/webmin
/etc/init.d/webmin
/etc/rc.d/rc2.d/S99webmin
/etc/rc.d/rc3.d/S99webmin
/etc/rc.d/rc5.d/S99webmin
/etc/rc.d/rc0.d/K10webmin
/etc/rc.d/rc1.d/K10webmin
/etc/rc.d/rc6.d/K10webmin
%config /etc/pam.d/webmin

%pre
if [ "$tempdir" = "" ]; then

	if [ ! -d /tmp/.webmin ]; then
		mkdir -p /tmp/.webmin
	fi

	tempdir=/tmp/.webmin
fi

# update the rpmsave folder config and normal config if a new pclos release is reached
RELEASE=$(cat /etc/mandrake-release | sed -e 's/PCLinuxOS release //g' | sed -e 's/(PCLinuxOS).*//g')
DIST=PCLinuxOS
# Note update the following sed statements in the year 10000 :P
if [ -e /etc/webmin ]; then
	# to cycle out the +PCLinuxOS from older releases
	sed -i "s/real_os_type=........../real_os_type=$DIST/g" /etc/webmin/config
	# update the release
	sed -i "s/real_os_version=..../real_os_version=$RELEASE/g" /etc/webmin/config
fi

if [ -e /etc/webmin.rpmsave ]; then 
	sed -i "s/real_os_type=........../real_os_type=$DIST/g" /etc/webmin.rpmsave/config
	sed -i "s/real_os_version=..../real_os_version=$RELEASE/g" /etc/webmin.rpmsave/config
fi

perl >/$$.check <<EOD;
if (-r "/etc/.issue") {
	\$etc_issue = \`cat /etc/.issue\`;
	}
elsif (-r "/etc/issue") {
	\$etc_issue = \`cat /etc/issue\`;
	}
\$uname = \`uname -a\`;
if (\`cat /etc/mandrake-release 2>/dev/null\` =~ /pclinuxos\\s+Linux\\s+release\\s+2005/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /pclinuxos\\s+Linux\\s+release\\s+2006/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2007/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2008/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2009/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2010/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2012/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2013/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2014/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2015/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2016/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2017/i) {
	print "oscheck='PCLinuxOS'\\n";
	}
elsif (\`cat /etc/mandrake-release 2>/dev/null\` =~ /PCLinuxOS\\s+release\\s+2018/i) {
	print "oscheck='PCLinuxOS'\\n";
	}


EOD
. /$$.check
rm -f /$$.check
if [ ! -r /etc/webmin/config ]; then
	if [ "$oscheck" = "" ]; then
		echo Unable to identify operating system
		exit 2
	fi
	echo Operating system is $oscheck
	if [ "$WEBMIN_PORT" != "" ]; then
		port=$WEBMIN_PORT
	else
		port=10000
	fi
	perl -e 'use Socket; socket(FOO, PF_INET, SOCK_STREAM, getprotobyname("tcp")); setsockopt(FOO, SOL_SOCKET, SO_REUSEADDR, pack("l", 1)); bind(FOO, pack_sockaddr_in($ARGV[0], INADDR_ANY)) || exit(1); exit(0);' $port
	if [ "$?" != "0" ]; then
		echo Port $port is already in use
		exit 2
	fi
fi
# Save /etc/webmin in case the upgrade trashes it
if [ "$1" != 1 ]; then
	rm -rf /etc/.webmin-backup
	cp -r /etc/webmin /etc/.webmin-backup
fi
# Put back old /etc/webmin saved when an RPM was removed
if [ "$1" = 1 -a ! -d /etc/webmin -a -d /etc/webmin.rpmsave ]; then
	mv /etc/webmin.rpmsave /etc/webmin
fi
/bin/true

%post
inetd=`grep "^inetd=" /etc/webmin/miniserv.conf 2>/dev/null | sed -e 's/inetd=//g'`
if [ "$1" != 1 ]; then
	# Upgrading the RPM, so stop the old webmin properly
	if [ "$inetd" != "1" ]; then
		/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
	fi
fi
cd /usr/libexec/webmin
config_dir=/etc/webmin
var_dir=/var/webmin
perl=/usr/bin/perl
autoos=3
if [ "$WEBMIN_PORT" != "" ]; then
	port=$WEBMIN_PORT
else
	port=10000
fi
login=root
if [ -r /etc/shadow ]; then
	#crypt=`grep "^root:" /etc/shadow | cut -f 2 -d :`
	crypt=x
else
	crypt=`grep "^root:" /etc/passwd | cut -f 2 -d :`
fi
host=`hostname`
ssl=1
atboot=1
nochown=1
autothird=1
noperlpath=1
nouninstall=1
nostart=1
if [ "$tempdir" = "" ]; then
	tempdir=/tmp/.webmin
fi
export config_dir var_dir perl autoos port login crypt host ssl nochown autothird noperlpath nouninstall nostart allow atboot
./setup.sh >$tempdir/webmin-setup.out 2>&1
chmod 600 $tempdir/webmin-setup.out
rm -f /var/lock/subsys/webmin
if [ "" != "1" ]; then
	/etc/init.d/webmin start >/dev/null 2>&1 </dev/null
fi
cat >/etc/webmin/uninstall.sh <<EOFF
#!/bin/sh
printf "Are you sure you want to uninstall Webmin? (y/n) : "
read answer
printf "\n"
if [ "\$answer" = "y" ]; then
	echo "Removing webmin RPM .."
	rpm -e --nodeps webmin
	echo "Done!"
fi
EOFF
chmod +x /etc/webmin/uninstall.sh
port=`grep "^port=" /etc/webmin/miniserv.conf | sed -e 's/port=//g'`
perl -e 'use Net::SSLeay' >/dev/null 2>/dev/null
sslmode=0
if [ "$?" = "0" ]; then
	grep ssl=1 /etc/webmin/miniserv.conf >/dev/null 2>/dev/null
	if [ "$?" = "0" ]; then
		sslmode=1
	fi
fi
musthost=`grep musthost= /etc/webmin/miniserv.conf | sed -e 's/musthost=//'`
if [ "" != "" ]; then
	host=
fi
if [ "$sslmode" = "1" ]; then
	echo "Webmin install complete. You can now login to https://$host:$port/"
else
	echo "Webmin install complete. You can now login to http://$host:$port/"
fi
echo "as root with your root password."
/bin/true

%preun
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Run uninstalls and stop the server
		echo "Running uninstall scripts .."
		(cd /usr/libexec/webmin ; WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin LANG= /usr/libexec/webmin/run-uninstalls.pl)
		/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
		/etc/webmin/stop >/dev/null 2>&1 </dev/null
	fi
fi
/bin/true

%postun
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Delete the config files
		rm -rf /etc/webmin.rpmsave
		mv /etc/webmin /etc/webmin.rpmsave
		rm -rf /etc/webmin /var/webmin
	fi
fi

# reset permissions in tmp for users
echo "Reset tmp permissions"
SYSUSERS=$(grep [0-9][0-9][0-9]:.*/home /etc/passwd | grep -f /etc/shells | cut -d: -f1)
for idx in $SYSUSERS
	do INP1= chown -R $idx:$idx /home/$idx/tmp; done
/bin/true

%triggerpostun -- webmin
if [ ! -d /var/webmin -a "$1" = 2 ]; then
	echo Re-creating /var/webmin directory
	mkdir /var/webmin
fi
if [ ! -r /etc/webmin/miniserv.conf -a -d /etc/.webmin-backup -a "$1" = 2 ]; then
	echo Recovering /etc/webmin directory
	rm -rf /etc/.webmin-broken
	mv /etc/webmin /etc/.webmin-broken
	mv /etc/.webmin-backup /etc/webmin
	/etc/init.d/webmin stop >/dev/null 2>&1 </dev/null
	/etc/init.d/webmin start >/dev/null 2>&1 </dev/null
else
	rm -rf /etc/.webmin-backup
fi
/bin/true


%posttrans
# reset permissions in tmp for users
echo "Reset tmp permissions"
SYSUSERS=$(grep [0-9][0-9][0-9]:.*/home /etc/passwd | grep -f /etc/shells | cut -d: -f1)
for idx in $SYSUSERS
 do INP1= chown -R $idx:$idx /home/$idx/tmp; done


%changelog
* Sun Dec 24 2017 ghostbunny <ghostbunny at gmx dot de> 1.870-1pclos2017
- 1.870

* Sun Dec 18 2016 ghostbunny <ghostbunny at gmx dot de> 1.820-1pclos2016
- 1.820
- prepare patch and spec for pclos 2017 release

* Sun Sep 25 2016 ghostbunny <ghostbunny at gmx dot de> 1.810-1pclos2016
- 1.810

* Sat Jul 30 2016 ghostbunny <ghostbunny at gmx dot de> 1.801-1pclos2016
- 1.801

* Thu Dec 31 2015 ghostbunny <ghostbunny at gmx dot de> 1.780-1pclos2016
- 1.780 and update for the 2016 release

* Mon Aug 17 2015 ghostbunny <ghostbunny at gmx dot de> 1.760-1pclos2015
- 1.760

* Fri Jan 30 2015 ghostbunny <ghostbunny at gmx dot de> 1.730-1pclos2015
- fix patch and pre script for 2015 release
- 1.730

* Thu Jun 05 2014 ghostbunny <ghostbunny at gmx dot de> 1.690-1pclos2014
- 1.690

* Sun Mar 23 2014 ghostbunny <ghostbunny at gmx dot de> 1.680-1pclos2014
- 1.680

* Sat Jan 24 2014 ghostbunny <ghostbunny at gmx dot de> 1.670-1pclos2014
- 1.670
- fix patch and pre scriptlet for PCLinuxOS 2014 release
- remove the distro check for suse, solaris, ... you will not find something like that
- add update part of the config for the case the release number of PCLOS was increased

* Tue Aug 20 2013 ghostbunny <ghostbunny at gmx dot de> 1.650-1pclos2013
- 1.650

* Tue May 21 2013 ghostbunny <ghostbunny at gmx dot de> 1.630-1pclos2013
- 1.630
- fixed patch line numbers and the contained mageia entry

* Tue Mar 05 2013 ghostbunny <ghostbunny at gmx dot de> 1.620-1pclos2013
- 1.620

* Thu Jan 10 2013 ghostbunny <ghostbunny at gmx dot de> 1.610-2pclos2013
- fixed patch and pre section for 2013 release

* Sat Nov 24 2012 Neal <nealbrks0 at gmail dot com> 1.610-1pclos2012
- process

* Wed Nov 21 2012 ghostbunny <ghostbunny at gmx dot de> 1.610-1pclos2012
- 1.610
- fixed patch

* Mon Oct 01 2012 Neal <nealbrks0 at gmail dot com> 1.600-1pclos2012
- process

* Mon Oct 01 2012 ghostbunny <ghostbunny at gmx dot de> 1.600-1pclos2012
- 1.600

* Fri Aug 24 2012 Neal <nealbrks0 at gmail dot com> 1.590-3pclos2012
- process

* Fri Aug 24 2012 Pinoc <vogtpet at gmail dot com> 1.590-3pclos2012
- fixed permissions in ~/tmp/

* Wed Aug 08 2012 Neal <nealbrks0 at gmail dot com> 1.590-2pclos2012
- process

* Tue Aug 07 2012 ghostbunny <ghostbunny at gmx dot de> 1.590-2pclos2012
- hopefully fixed the tmp dir permissions

* Sun Jul 29 2012 ghostbunny <ghostbunny at gmx dot de> 1.590-1pclos2012
- 1.590
- added german summary and description
- fixed patch to match current pclos2012 version
- synced the spec a bit more to spec from the developer
- added xz compression
- renamed spec to pclos-webmin.spec
- replaced deprecated non supported PreReq: by Requires(pre):

* Thu Sep 17 2009 Texstar <texstar@gmail.com> 1.490-1pclos2009
- 1.490

* Fri Jul 24 2009 Texstar <texstar@gmail.com> 1.480-1pclos2009
- update

* Wed Jun 10 2009 Joble <joble@pclosbe.org> 1.470-1pclos2009
- Update for PCLinuxOS 2009

* Mon Nov 13 2006 Texstar <texstar@houston.rr.com> 1.290-5pclos2007
- Build for PCLinuxOS 2007
